#!/usr/bin/python

__author__ = "Michael Lienhardt"
__copyright__ = "Copyright 2019, Michael Lienhardt"
__license__ = "GPL3"
__version__ = "1"
__maintainer__ = "Michael Lienhardt"
__email__ = "michael lienhardt@onera.fr"
__status__ = "Prototype"

# Simple containers for constants and enums
class container(object):
  def __init__(self, **kwargs): self.__dict__.update(kwargs)


# Simple skeleton for visitors
class element(object):
  def accept(self, visitor): return getattr(visitor, self.__class__.__name__)(self)

class visitor(object):
  def visit(self, el): return el.accept(self)

# add attribute to a class, taken from https://medium.com/@mgarod/dynamically-add-a-method-to-a-class-in-python-c49204b85bd6
def add_method(cls, name=None):
  def decorator(func):
    setattr(cls, name if(name != None) else func.__name__, func)
    return func # returning func means func can still be used normally
  return decorator

